%bcond_without check

%global goipath         github.com/pquerna/ffjson
%global commit          aa0246cd15f76c96de6b96f22a305bdfb2d1ec02

%gometa

%global common_description %{expand:
Ffjson generates static MarshalJSON and UnmarshalJSON functions for structures
in Go. The generated functions reduce the reliance upon runtime reflection to do
serialization and are generally 2 to 3 times faster. In cases where ffjson
doesn't understand a Type involved, it falls back to encoding/json, meaning it
is a safe drop in replacement. By using ffjson your JSON serialization just gets
faster with no additional code changes.}

%global golicenses      LICENSE NOTICE
%global godocs          README.md

Name:           %{goname}
Version:        0
Release:    1%{?dist}
Summary:        Faster JSON serialization for Go

License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

%if %{with check}
BuildRequires:  golang(github.com/google/gofuzz)
BuildRequires:  golang(github.com/stretchr/testify/require)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
rm -rf tests/types/ff

%build
%gobuild -o %{gobuilddir}/bin/ffjson %{goipath}

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
%gocheck -d tests
%endif

%files
%license LICENSE NOTICE
%doc README.md
%{_bindir}/*

%gopkgfiles

%changelog
* Fri Sep 06 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0-1
- initial build
